#
# Conditional build:
%bcond_without	doc	# API documentation
%bcond_without	tests	# unit tests

Summary:	Aspect-oriented programming, monkey-patch and decorators library
Summary(pl.UTF-8):	Biblioteka programowania zorientowanego aspektowo, małpich łatek i dekoratorów
Name:		python3-aspectlib
Version:	2.0.0
Release:	1
License:	BSD
Group:		Libraries/Python
#Source0Download: https://pypi.org/simple/aspectlib/
Source0:	https://files.pythonhosted.org/packages/source/a/aspectlib/aspectlib-%{version}.tar.gz
# Source0-md5:	427f325a4a9a5dc85563cbb08569bcd9
Patch0:		aspectlib-pytest.patch
Patch1:		aspectlib-exception.patch
URL:		https://pypi.org/project/aspectlib/
BuildRequires:	python3-modules >= 1:3.7
BuildRequires:	python3-setuptools >= 1:30.3.0
%if %{with tests}
BuildRequires:	python3-fields
BuildRequires:	python3-process_tests
BuildRequires:	python3-pytest
BuildRequires:	python3-tornado
%endif
BuildRequires:	rpm-pythonprov
BuildRequires:	rpmbuild(macros) >= 1.714
%if %{with doc}
BuildRequires:	python3-sphinx_py3doc_enhanced_theme
BuildRequires:	sphinx-pdg-3 >= 1.3
%endif
Requires:	python3-modules >= 1:3.7
BuildArch:	noarch
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
aspectlib is an aspect-oriented programming, monkey-patch and
decorators library. It is useful when changing behavior in existing
code is desired. It includes tools for debugging and testing: simple
mock/record and a complete capture/replay framework.

%description -l pl.UTF-8
aspectlib to biblioteka programowania zorientowanego aspektowo,
małpich łatek i dekoratorów. Jest przydatna do zmiany zachowania
istniejącego kodu. Zawiera narzędzi do diagnostyki i testowania:
prostą atrapę/zapis oraz kompletny szkielet
przechwytywania/odtwarzania.

%package apidocs
Summary:	API documentation for Python aspectlib module
Summary(pl.UTF-8):	Dokumentacja API modułu Pythona aspectlib
Group:		Documentation

%description apidocs
API documentation for Python aspectlib module.

%description apidocs -l pl.UTF-8
Dokumentacja API modułu Pythona aspectlib.

%prep
%setup -q -n aspectlib-%{version}
%patch -P0 -p1
%patch -P1 -p1

%build
%py3_build

%if %{with tests}
# disable tests using localhost networking
PYTEST_DISABLE_PLUGIN_AUTOLOAD=1 \
PYTHONPATH=$(pwd)/src \
%{__python3} -m pytest tests -k 'not test_socket and not test_socket_as_string_target and not test_realsocket_makefile'
%endif

%if %{with doc}
PYTHONPATH=$(pwd)/src \
sphinx-build-3 -b html docs docs/_build/html
%endif

%install
rm -rf $RPM_BUILD_ROOT

%py3_install

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(644,root,root,755)
%doc AUTHORS.rst CHANGELOG.rst LICENSE README.rst
%{py3_sitescriptdir}/aspectlib
%{py3_sitescriptdir}/aspectlib-%{version}-py*.egg-info

%if %{with doc}
%files apidocs
%defattr(644,root,root,755)
%doc docs/_build/html/{_modules,_static,presentations,reference,*.html,*.js}
%endif
%changelog
* Sun Jun 29 2025 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/python3-aspectlib.git;a=log;h=master

* Sun Jun 29 2025 Jakub Bogusz <qboosh@pld-linux.org> b58894e
- python-aspectlib.spec updated to 2.0.0 for python 3.7+

* Sun Jun 29 2025 Jakub Bogusz <qboosh@pld-linux.org> be55695
- new

